

/*
This is a UI file (.ui.qml) that is intended to be edited in Qt Design Studio only.
It is supposed to be strictly declarative and only uses a subset of QML. If you edit
this file manually, you might introduce QML code that is not supported by Qt Design Studio.
Check out https://doc.qt.io/qtcreator/creator-quick-ui-forms.html for details on .ui.qml files.
*/
import QtQuick 6.7
import QtQuick.Controls 6.7
import QtQuick3D 6.7
import QtQuick3D.Effects 6.7
import SimpleEffectComposerDemo
import Generated.QtQuick3D.Monkey
import QtQuick.Studio.Components 1.0
import Generated.Effects.SwirlEffect 1.0
import QtQuick.Timeline 1.0

Rectangle {
    id: rectangle
    width: Constants.width
    height: Constants.height
    color: "#373f26"

    View3D {
        id: view3D
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        anchors.leftMargin: 700

        environment: sceneEnvironment

        SceneEnvironment {
            id: sceneEnvironment
            antialiasingMode: SceneEnvironment.MSAA
            antialiasingQuality: SceneEnvironment.High
        }

        Node {
            id: scene
            DirectionalLight {
                id: directionalLight
                x: 408.464
                y: -269.96
                z: 269.96051
            }

            PerspectiveCamera {
                id: sceneCamera
                z: 350
            }

            Monkey {
                id: monkey
                x: 0
                eulerRotation.y: rotationSlider.value
                z: 0
            }
        }

        SwirlEffect {
            id: swirlEffect
            visible: effectSwitch.checked
        }
    }

    Item {
        id: __materialLibrary__
        PrincipledMaterial {
            id: defaultMaterial
            objectName: "Default Material"
            baseColor: "#4aee45"
        }
    }

    GroupItem {
        id: uiControlsGroup
        height: 249
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: parent.left
        anchors.right: view3D.left
        anchors.leftMargin: 200
        anchors.rightMargin: 0

        Row {
            id: effect
            height: 98
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            anchors.leftMargin: 0
            anchors.rightMargin: 0
            anchors.topMargin: 0

            Text {
                id: effectText
                color: "#ffffff"
                text: qsTr("Effect visibility")
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: parent.left
                anchors.leftMargin: 0
                font.pixelSize: 35
            }
            CustomSwitch {
                id: effectSwitch
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: effectText.right
                anchors.leftMargin: 25
                anchors.verticalCenterOffset: 2
                checked: true
            }
        }

        Column {
            id: rotation
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: effect.bottom
            anchors.bottom: parent.bottom
            anchors.leftMargin: 0
            anchors.rightMargin: 0
            anchors.topMargin: 35
            anchors.bottomMargin: 0

            Text {
                id: rotationText
                color: "#ffffff"
                text: qsTr("Rotation")
                anchors.left: parent.left
                anchors.top: parent.top
                anchors.leftMargin: 0
                anchors.topMargin: 0
                font.pixelSize: 35
            }

            Row {
                id: row
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.top: rotationText.bottom
                anchors.bottom: parent.bottom
                anchors.leftMargin: 0
                anchors.rightMargin: 0
                anchors.topMargin: 0
                anchors.bottomMargin: 0

                CustomSlider {
                    id: rotationSlider
                    value: 0
                    anchors.left: parent.left
                    anchors.right: rotationAmountText.left
                    anchors.top: parent.top
                    anchors.bottom: parent.bottom
                    anchors.leftMargin: 0
                    anchors.rightMargin: 10
                    anchors.topMargin: 0
                    anchors.bottomMargin: 0
                    to: 360
                }

                Text {
                    id: rotationAmountText
                    width: 29
                    height: 57
                    color: "#ffffff"
                    text: rotationSlider.value.toFixed(0)
                    anchors.verticalCenter: rotationSlider.verticalCenter
                    anchors.right: parent.right
                    anchors.rightMargin: 0
                    font.pixelSize: 35
                }
            }
        }
    }
}

/*##^##
Designer {
    D{i:0}D{i:3;cameraSpeed3d:25;cameraSpeed3dMultiplier:1}
}
##^##*/

